/* NRM-FPGA: an NRM solver on an FPGA
 * 
 * Copyright (C) 2004-2009, Amano Lab., Keio University.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

`include "define.vh"

module carb1_single(CLK, RST,
                  REQ,
                  ACK,
                  CRDY);

   input  CLK, RST;
   input  REQ;
   output ACK;
   input  CRDY;
   
   reg    ACK;
   
   reg    PRIORITY;
   
   wire   EV;
   
   assign       EV = REQ & CRDY;

   always@(posedge CLK) begin
      if(RST) begin
         ACK      <= 1'b0;
      end
      else begin
         if(EV) ACK <= 1'b1;
         else   ACK <= 1'b0;
      end
   end

endmodule
