/* NRM-FPGA: an NRM solver on an FPGA
 * 
 * Copyright (C) 2004-2009, Amano Lab., Keio University.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

`define DUNIT_STATE_INIT  5'b11111
`define DUNIT_STATE_STRT  5'b00001
`define DUNIT_STATE_IDLE  5'b00010
`define DUNIT_STATE_FTCH  5'b00100
`define DUNIT_STATE_UPDT  5'b01000
`define DUNIT_STATE_REAS  5'b10000
`define DUNIT_STATE_LOOP  5'b10001
`define DUNIT_STATE_PRCS  5'b10010
`define DUNIT_STATE_TCAL  5'b10011

`define OP_IDLE   4'b0000
`define OP_DGTB   4'b0110
`define OP_UPDT   4'b0111
`define OP_REAS   4'b1000
`define OP_PRCS   4'b1010
`define OP_TCAL   4'b1100
`define OP_TMOD   4'b1101
`define OP_LOOP   4'b1110

`define OP_REAB   4'b1001
`define OP_PRCB   4'b1011
